/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Internet Radio Automation & Encoding Toolkit
#+
#+     Copyright (C) 2018, 2019, 2020, 2021, 2022, 2023 
#+     by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     kc.okane@gmail.com
#+     https://www.cs.uni.edu/~okane
#+     https://threadsafebooks.com/
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

//	Jan 27, 2024

#include "includes.h"
#include "defines.h"
#include "common-externs.h"
#include "common-fcn-headers.h"


//ffmpeg -i LaTraviata-720x480-01-audLvl-01.mp4 -filter_complex bass=gain=20:frequency=250 aaa.mp4


#include <vlc/libvlc.h>
#include <vlc/libvlc_renderer_discoverer.h>
#include <vlc/libvlc_media.h>
#include <vlc/libvlc_media_player.h>

#define SLASH '/'


void    on_audio_ok_clicked(GtkButton *b) { // ok button dbx9

	close_boxes();

	audio_modify();


	clear_play();
	}


void    on_xtext_end_value_changed(GtkSpinButton *s) {
        text_y = gtk_spin_button_get_value(s) / text_scale;
        gtk_fixed_move (GTK_FIXED(text_fixed), text_image, text_x, text_y);
        }

void    on_xtext_start_value_changed(GtkSpinButton *s) {
        text_x = gtk_spin_button_get_value(s) / text_scale;
        gtk_fixed_move (GTK_FIXED(text_fixed), text_image, text_x, text_y);
        }

