/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Internet Radio Automation & Encoding Toolkit
#+
#+     Copyright (C) 2018, 2019, 2020, 2021, 2022, 2023 
#+     by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     kc.okane@gmail.com
#+     https://www.cs.uni.edu/~okane
#+     https://threadsafebooks.com/
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

//	Jan 30, 2024

#include "includes.h"
#include "defines.h"
#include "common-externs.h"
#include "common-fcn-headers.h"


#include <vlc/libvlc.h>
#include <vlc/libvlc_renderer_discoverer.h>
#include <vlc/libvlc_media.h>
#include <vlc/libvlc_media_player.h>

#define SLASH '/'


//-------------------
//	MAKE CLIP
//-------------------

void	on_make_clip_clicked(GtkWidget *w) {
	char tmp[16000];
	char tmp1[16000];
	int err_stat = 0;
	int i, j;

	if (!mediaPlayer) {
		zippy_says("No file being played.\n");
		return;
		}

	printf("Show wait label\n");

        if (!gtk_toggle_button_get_active(frame_next))
                gtk_toggle_button_set_active(frame_next, TRUE);

//	vlc_pause();

	int file_code = filetype(SP->playThis);

	if (file_code == MP3 ||
            file_code == WMA ||
            file_code == OGG ||
            file_code == WAV ||
            file_code == FLAC ||
            file_code == WMV) {

        	outfade = gtk_spin_button_get_value(out_fade);
        	infade = gtk_spin_button_get_value(in_fade);

		char tmp[4096];

		sprintf(tmp,"cp  \"%s/icons/sgv.jpg\" \"%s/myimage.jpg\" ", Code_Home, Code_Home);

		err_stat = err_stat + ff_run("aud1", tmp, -1);

		sprintf(tmp,"cp \"%s/icons/sgv.jpg\" \"%s/myimage1.jpg\" ", Code_Home, Code_Home);

		err_stat = err_stat + ff_run("aud1", tmp, -1);

                sprintf(tmp,
                        "ffmpeg -y -loglevel info -i \"%s\" -ss %d -to %d \"%s\" ",

                        SP->playThis,
                        clip_start / 1000,
                        (clip_end) / 1000,

                        "tmp.flac");

		err_stat = err_stat + ff_run("aud1", tmp, -1);

		sprintf(tmp,
			"ffmpeg -y -loglevel info -loop 1 -i \"%s/icons/sgv.jpg\" "
			" -i tmp.flac -shortest  -c:a libopus -b:a 128k -c:v libx264 -preset veryslow -crf 20  -tune stillimage  "
			" -pix_fmt yuv420p tmp1.mp4", Code_Home);

		err_stat = err_stat + ff_run("aud", tmp, -1);

                sprintf(tmp,
                        "ffmpeg -y -loglevel info -i \"%s\" -to %d \"%s\" ",
			"tmp1.mp4",
                        (clip_end - clip_start) / 1000,

                        "tmp.mp4");

		err_stat = err_stat + ff_run("aud2", tmp, -1);

		goto xxx;

		}

/*****************************************************************
	for (i = strlen(SP->playThis); i > 0; i--) {
		if (SP->playThis[i] == '.') break;
		}
		
	if (i == 0) strcpy(tmp1, "out.mp4");

	else {
		tmp1[i--] = 0;
		for (j = i; j >= 0; j--)
			tmp1[j] = SP->playThis[j]; 
		}
*****************************************************************/


	time_t tmark = time(0);

//------------------------------------------------------------------
//	model crop command
//
//	ffmpeg -i in.mp4 -filter:v "crop=out_w:out_h:x:y" out.mp4
//		(int) x_sz, (int) y_sz, (int) x_co, (int) y_co,
//
//	model video fade
//
//	ffmpeg -i video.mp4 -vf "fade=t=in:st=0:d=3" -c:a copy out.mp4
//----------------------------------------------------------------------

	if (rotation == 0) 

		libvlc_video_get_size (mediaPlayer, 0, &frame_width, &frame_height);

	else if (rotation == 90)

        	libvlc_video_get_size (mediaPlayer, 0, &frame_height, &frame_width);

	else {
		zippy_says("Error: only cell phone rotations 0 and 90 accepted at this time.\n");
		strcpy(tmp, "rm -f ");
		strcat(tmp, "tmp.mp4");
		system(tmp);
		printf("\n%s\n", tmp);
		}
        

	printf("\n");
	printf("width = %d height = %d\n", frame_width, frame_height);

	char new[16000];

	if (clip_end == 0 || clip_end - clip_start < 0) {
		clip_end = libvlc_media_player_get_length (mediaPlayer);
		}

        outfade = gtk_spin_button_get_value(out_fade);
        infade = gtk_spin_button_get_value(in_fade);

	if (infade < 0.1 && outfade < 0.1)

		sprintf(tmp,
			"ffmpeg -y -loglevel info -ss %d -i \"%s\" "
			"-to %d -c:a aac -vf fps=25,\"crop=w=%d:h=%d:x=%d:y=%d \" "
			" -c:a libopus -b:a 128k -c:v libx264 -preset veryslow -crf 20  \"%s\" ",

			clip_start / 1000, 
			SP->playThis, 
			(clip_end - clip_start) / 1000,

			(int) (frame_width - (cropLeft+cropRight)), 
			(int) (frame_height - (cropBottom+cropTop)), 

			(int) cropLeft, (int) cropTop,
			"tmp.mp4");

	else if (infade < 0.1 && outfade > 0.0)
	
		sprintf(tmp,
			"ffmpeg -y -loglevel info -ss %d -i \"%s\" "
			"-to %d -c:a aac -vf fps=25,\"crop=w=%d:h=%d:x=%d:y=%d, "
			" fade=out:st=%d:d=%d\" "
			"-af \"afade=t=out:st=%d:d=%d\" "
			" -c:a libopus -b:a 128k -c:v libx264 -preset veryslow -crf 20  \"%s\" ",
	
			clip_start / 1000, 
			SP->playThis, 
			(clip_end - clip_start) / 1000,
	
			(int) (frame_width - (cropLeft+cropRight)), 
			(int) (frame_height - (cropBottom+cropTop)), 
	
			(int) cropLeft, (int) cropTop,
			(int) (((clip_end - clip_start) / 1000) - outfade), 
			(int) outfade,					// video outfade
			(int) (((clip_end - clip_start) / 1000) - outfade), 
			(int) outfade,					// audio outfade
			"tmp.mp4");

	else if (infade > 0.0 && outfade < 0.1)

		sprintf(tmp,
			"ffmpeg -y -loglevel info -ss %d -i \"%s\" "
			"-to %d -c:a aac -vf fps=25,\"crop=w=%d:h=%d:x=%d:y=%d, "
			"fade=in:st=0:d=%d \" "
			"-af \"afade=t=in:st=0:d=%d \" "
			" -c:a libopus -b:a 128k -c:v libx264 -preset veryslow -crf 20  \"%s\" ",
	
			clip_start / 1000, 
			SP->playThis, 
			(clip_end - clip_start) / 1000,
	
			(int) (frame_width - (cropLeft+cropRight)), 
			(int) (frame_height - (cropBottom+cropTop)), 
	
			(int) cropLeft, (int) cropTop,
			(int) infade,					// video infade
			(int) infade, 					// audio infade
			"tmp.mp4");

	else {
		sprintf(tmp,
			"ffmpeg -y -loglevel info -ss %d -i \"%s\" "
			"-to %d -c:a aac -vf fps=25,\"crop=w=%d:h=%d:x=%d:y=%d, "
			"fade=in:st=0:d=%d, fade=out:st=%d:d=%d\" "
			"-af \"afade=t=in:st=0:d=%d, afade=t=out:st=%d:d=%d\" "
			" -c:a libopus -b:a 128k -c:v libx264 -preset veryslow -crf 20  \"%s\" ",
	
			clip_start / 1000, 
			SP->playThis, 
			(clip_end - clip_start) / 1000,
	
			(int) (frame_width - (cropLeft+cropRight)), 
			(int) (frame_height - (cropBottom+cropTop)), 
	
			(int) cropLeft, (int) cropTop,
			(int) infade,					// video infade
			(int) (((clip_end - clip_start) / 1000) - outfade), 
			(int) outfade,					// video outfade
			(int) infade, 					// audio infade
			(int) (((clip_end - clip_start) / 1000) - outfade), 
			(int) outfade,					// audio outfade
			"tmp.mp4");

		}

	err_stat = ff_run("Clip", tmp, -1);

xxx: 

	if (err_stat == 0) {
		char rslt[8192];
		char tmp2[16000];
		file_probe("tmp.mp4", SP->playThis, rslt);

		sprintf(tmp2, "cp %s \"%s\"", "tmp.mp4", rslt);
		system(tmp2);
		printf("\n%s\n", tmp2);

		sprintf(tmp2, "rm -f %s", "tmp.flac tmp1.mp4 tmp.mp4 ");
		system(tmp2);
		printf("\n%s\n", tmp2);

		addToTop(rslt);

//		run_result_flag = 5;
		sprintf(tmp2, "Created: %s\nThis clip may need to be normalized.\n", rslt);
		zippy_says(tmp2);
		}

	else {
		zippy_says("An error occured\n");

		strcpy(tmp, "rm -f ");
		strcat(tmp, "tmp.mp4");
		system(tmp);
		printf("\n%s\n", tmp);
		}


//	gtk_widget_show(drawV);
	clear_play();

	}

